<?php

namespace App\Models;

use App\Entities\TipoExtorno\TipoExtorno;

// use const False\MyClass\true;
class TipoExtornoModel extends ModelEntity {
	protected $table = 'tipo_extorno';
	protected $primaryKey = 'id';
	protected $returnType = 'array';
	protected $allowedFields = [ 
			'descricao',
			'criado_por',
			'data_criacao',
			'hora_criacao'
	];
	protected $useSoftDeletes = false;
	protected $skipValidation = true;
	protected $useTimestamps = false;

	public function registerTipoExtorno(TipoExtorno $tipoExtorno): void {

		$id_new_tipo_extorno = $this->insert( $tipoExtorno->toArray( true ) );
		$tipoExtorno->setId( $id_new_tipo_extorno );

	}

	public function updateTipoExtornoByID(int $id_tipo_extorno, TipoExtorno $tipo_extorno): bool {

		$data = $tipo_extorno->toArray( true );
		$binds = [ 
				'id_tipo_extorno' => $id_tipo_extorno
		];
		$sets = $this->generateUpdateSets( $data, $binds );
		$sql = "UPDATE tipo_extorno $sets WHERE tipo_extorno.id = :id_tipo_extorno:";
		$query = $this->db->query( $sql, $binds );
		return $query->connID->affected_rows === 1;

	}

}
